/*
 Name:    ArduinoSoftI2c-Test
 Created: 2022-11-07
 Author:  Ulli (https://ullisroboterseite.de)
 Docs:    https://ullisroboterseite.de/arduino-soft-i2c.html
*/


#include <UrsArduinoSofti2c.h>

const uint8_t sda = 8; // SDA pin is pin 8
const uint8_t scl = 9; // SCL pin is pin 9
uint8_t devAdr = 0x30; // Device address

uint8_t readBuffer[] = { 0, 0 };
uint8_t zeroRegAdr = 0;
uint8_t count = 0;


UrsArduinoSoftI2cClass& i2c = SoftI2c; 

void setup() {
   Serial.begin(9600);
   delay(10);
   Serial.println("I2C-Test");

   i2c.begin(sda, scl);

   uint8_t rtc = i2c.readPacket(0, readBuffer, 1); // read address
   if (rtc == 1) {
      devAdr = readBuffer[0];
      Serial.print("Device address: "); Serial.println(readBuffer[0]);
   }
   else {
      Serial.println("Device address cannot be determined");
      while (true); // ... and stopp
   }
}



void loop() {
   count++;

   uint8_t rtc = i2c.writeToRegister(devAdr, 1, &count, 1);
   if (rtc == 1) {
      Serial.println("Write ok");
   }
   else
      Serial.println("Write error");

   rtc = i2c.readFromRegister(devAdr, 0, readBuffer, sizeof(readBuffer));
   if (rtc == sizeof(readBuffer)) {
      Serial.print("read ok: "); Serial.print(readBuffer[0]); Serial.print(" "); Serial.println(readBuffer[1]);
   }
   else
      Serial.println("read error");

   Serial.println();
   delay(1000);
}
